package com.webchat.domain.vo.dto;

import com.webchat.service.queue.dto.BaseQueueDTO;
import lombok.Data;

import java.util.Date;

/**
 * @Author 程序员七七
 * @webSite https://www.coderutil.com
 * @Date 2022/11/13 00:35
 * @description 基础消息
 */
@Data
public class BaseMessageDTO extends BaseQueueDTO {

    /**
     * 消息分类
     */
    private String category;

    /**
     * 消息类型
     */
    private String type;

    /***
     * 消息正文
     */
    private String content;

    /**
     * 消息发送人
     */
    private String fromUserId;

    /**
     * 消息接收人
     */
    private String toUserId;

    /**
     * 是否读取
     */
    private Boolean isRead = false;

    /**
     * 消息发送时间
     */
    private Date createDate;

    /**
     * 消息读取时间
     */
    private Date readDate;
}
