package com.webchat.domain.vo.request.lottery;

import lombok.Data;

/**
 * @Author 程序员七七
 * @webSite https://www.coderutil.com
 * @Date 2022/11/16 22:53
 * @description
 */
@Data
public class LotteryItemSaveVO {

    /**
     * 活动id
     */
    private Long id;

    /**
     * 关联活动ID
     */
    private String activityId;

    /**
     * 商品类型
     * @see com.coder.common.constants.LotteryConstants.LotteryItemType
     */
    private Integer type;

    /**
     * 奖品名称
     */
    private String name;

    /**
     * 奖品icon
     */
    private String icon;

    /**
     * 奖品封面图
     */
    private String cover;

    /**
     * 卡槽 1，2，3 ...... 8
     */
    private Integer slot;

    /**
     * 库存数量
     */
    private Integer stock;
}
