package com.webchat.domain.vo.request.mess;

import com.webchat.common.enums.ChatMessageTypeEnum;
import lombok.Data;

/**
 * @Date: 10.9.22 11:38 下午
 */
@Data
public class MessageBaseVO {

    /**
     * 当前用户ID
     */
    private String senderId;

    /**
     * 聊天对象用户ID
     */
    private String receiverId;

    /**
     * 代理用户（群聊真是消息发送用户）
     */
    private String proxySenderId;

    /**
     * 消息文本正文
     */
    private String message;

    /**
     * 类型
     * @see com.webchat.common.enums.ChatMessageTypeEnum
     */
    private Integer type = ChatMessageTypeEnum.CHAT_TEXT.getType();
}
