package com.webchat.domain.vo.response.lottery;

import lombok.Data;

import java.math.BigDecimal;

/**
 * @Author 程序员七七
 * @webSite https://www.coderutil.com
 * @Date 2022/11/18 01:37
 * @description
 */
@Data
public class LotteryActivityBaseVO {

    private Long id;

    /**
     * 活动id
     */
    private String activityId;

    /**
     * 活动名称
     */
    private String name;

    /**
     * 活动描述
     */
    private String description;

    /**
     * 每抽奖一次需要消耗的金币
     */
    private Integer integral;

    /**
     * 活动海报图
     */
    private String cover;

    /**
     * 每次抽奖需要消耗的钱数
     */
    private BigDecimal money;

    /**
     * 用户初始钱包余额
     */
    private BigDecimal userInitWalletBalance;

    /**
     * 活动当前状态
     */
    private Integer status;

    /**
     * 状态名称
     */
    private String statusName;

    private Long createTime;
}
