package com.webchat.domain.vo.response.lottery;

import com.webchat.common.constants.LotteryConstants;
import lombok.Data;

/**
 * @Author 程序员七七
 * @webSite https://www.coderutil.com
 * @Date 2022/11/17 01:01
 * @description
 */
@Data
public class LotteryItemVO {

    /**
     * 奖项id
     */
    private Long id;

    /**
     * 关联活动ID
     */
    private String activityId;

    /**
     * 商品类型
     */
    private Integer type;

    private String typeName;

    /**
     * 奖品名称
     */
    private String name;

    /**
     * 奖品icon
     */
    private String icon;

    /**
     * 奖品封面图
     */
    private String cover;

    /**
     * 卡槽 1，2，3 ...... 8
     */
    private Integer slot;

    /**
     * 库存数量
     */
    private Integer stock;

    private Long createTime;

    public String getTypeName() {
        return LotteryConstants.getLotteryActivityItemTypeName(type);
    }
}
