package com.webchat.domain.vo.response.lottery;

import com.webchat.domain.vo.response.UserBaseResponseInfoVO;
import lombok.Data;

/**
 * @Author 程序员七七
 * @webSite https://www.coderutil.com
 * @Date 2022/11/19 10:58
 * @description
 */
@Data
public class LotteryUserOrderVO {

    /**
     * 订单号
     */
    private String orderId;

    /**
     * 中奖用户
     */
    private UserBaseResponseInfoVO user;

    /**
     * 活动
     */
    private LotteryActivityBaseVO activity;

    /**
     * 中奖商品
     */
    private LotteryItemVO item;

    /**
     * 订单状态code
     */
    private Integer orderStatus;

    /**
     * 订单状态
     */
    private String orderStatusName;

    /**
     * 中奖时间
     */
    private long luckTime;

    /**
     * 兑换时间
     */
    private long exchangeTime;
}
