package com.webchat.domain.vo.response.publicaccount;

import com.webchat.domain.vo.response.UserBaseResponseInfoVO;
import lombok.Data;

@Data
public class ArticleBaseResponseVO {

    /**
     * 文章id
     */
    private Long id;

    /**
     * 作者
     */
    private String author;

    /**
     * 公众号
     */
    private String publicAccount;

    private UserBaseResponseInfoVO publicAccountInfo;

    /**
     * 文章计划推送时间，13位时间戳，精确到秒
     */
    private Long planPushTime;


    private Long publishTime;


    /**
     * 文章标题
     */
    private String title;

    /**
     * 文章封面主图
     */
    private String cover;

    /**
     * 文章总结
     */
    private String description;

    /**
     * 文章正文
     */
    private String content;

    /**
     * 文章标签
     */
    private String signs;

    /**
     * 文章跳转链接
     */
    private String redirectUrl;

    /**
     * 文章状态
     *
     * @see com.webchat.common.enums.ArticleStatusEnum
     */
    private Integer status;
}
