package com.webchat.repository.dao;

import com.webchat.repository.entity.MessageTemplateEntity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.stereotype.Repository;

/**
 * @Author: 程序员王七七 https://www.coderutil.com 网站作者
 * @Date: 2021-7-24 0024 22:35
 * @Description: 无描述信息
 */
@Repository
public interface IMessageTemplateDAO extends JpaRepository<MessageTemplateEntity, Long>, JpaSpecificationExecutor<MessageTemplateEntity> {


    MessageTemplateEntity findAllByCode(String code);
}
