package com.webchat.repository.dao;

import com.webchat.repository.entity.SlideVerificationEntity;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @Author 程序员七七
 * @webSite https://www.coderutil.com
 * @Date 2024/9/18 23:30
 * @description
 */
@Repository
public interface ISlideVerificationEntityDAO extends JpaSpecificationExecutor<SlideVerificationEntity>,
        JpaRepository<SlideVerificationEntity, Long> {

    List<SlideVerificationEntity> findAllByStatus(Integer status);

    Page<SlideVerificationEntity> findAllByStatus(Integer status, Pageable pageable);
}
