package com.webchat.repository.dao.lottery;

import com.webchat.repository.entity.lottery.LotteryOrderEntity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.stereotype.Repository;

/**
 * @Author 程序员七七
 * @webSite https://www.coderutil.com
 * @Date 2022/11/16 23:49
 * @description
 */
@Repository
public interface ILotteryOrderDAO extends JpaSpecificationExecutor<LotteryOrderEntity>,
        JpaRepository<LotteryOrderEntity, Long> {

    /**
     * 根据订单id查询订单详情
     * @param orderId
     * @return
     */
    LotteryOrderEntity findByOrderId(String orderId);

}
