package com.webchat.service.ai;


import com.webchat.domain.vo.llm.image.ImageGenerateResponse;
import com.webchat.domain.vo.llm.image.RequestGenerateBase;

public abstract class AbstractGenerateImageService<T extends RequestGenerateBase> {


    protected abstract ImageGenerateResponse generate(String userId, T param) throws Exception;

    /**
     * 文生图
     *
     * @param param
     * @return
     */
    protected abstract String doSubmit(T param) throws Exception;


    /**
     * 查询生图结果
     *
     * @param taskId
     * @return
     */
    protected abstract ImageGenerateResponse getResult(String taskId) throws Exception;
}
