package com.webchat.domain.vo.request.lottery;

import lombok.Data;

import java.math.BigDecimal;

/**
 * @Author 程序员七七
 * @webSite https://www.coderutil.com
 * @Date 2022/11/16 22:53
 * @description
 */
@Data
public class LotteryActivitySaveVO {

    /**
     * 活动id
     */
    private Long id;

    /**
     * 活动名称
     */
    private String name;

    /**
     * 活动描述
     */
    private String description;

    /**
     * 活动海报图
     */
    private String cover;

    /**
     * 每次抽奖需要消耗钱数
     */
    private BigDecimal money;

}
