package com.webchat.domain.vo.response;

import lombok.Data;

import java.math.BigDecimal;

/**
 * @author 程序员七七， https://www.coderutil.com网站作者
 * @date 2024/11/9 04:43
 */
@Data
public class RedPacketDetailVO {

    /**
     * 红包id
     */
    private Long id;

    /**
     * 红包发送人信息
     */
    private String sendUserId;

    /**
     * 红包接受人信息：普通用户或者群聊
     */
    private String receiverUserId;

    /**
     * 拼手气、普通红包（平均分配）
     */
    private Integer type;

    /**
     * 总金额
     */
    private BigDecimal totalMoney;

    /**
     * 一共几个，发给个人只能一次拆一个，发给群聊可以配置多个
     */
    private Integer count;

    /**
     * 状态
     */
    private Integer status;

    /**
     * 发送时间
     */
    private Long sendTime;

    /**
     * 失效时间
     */
    private Long expireTime;

    /**
     * 是否有抢到
     */
    private boolean isGet;
}
