package com.webchat.domain.vo.response;

import lombok.Data;

/**
 * @Author: 程序员王七七 https://www.coderutil.com 网站作者
 * @Date: 2021-7-25 0025 0:07
 * @Description: 无描述信息
 */
@Data
public class UserUnReadMessageCountVO {

    /***
     * 未读点赞消息数
     */
    private Long unReadLikeMessageCount = 0L;

    /***
     * 未读评论消息数
     */
    private Long unReadCommentMessageCount = 0L;

    /***
     * 未读系统消息数
     */
    private Long unReadSystemMessageCount = 0L;

    /***
     * 未读粉丝关注消息数
     */
    private Long unReadFocusMessageCount = 0L;

    /***
     * 全部未读消息数
     * @return
     */
    public Long getUnReadAllMessageCount() {
        return this.unReadLikeMessageCount +
                this.unReadFocusMessageCount +
                this.unReadCommentMessageCount +
                this.unReadSystemMessageCount;
    }
}
